libzypp: zypp::ResStatus Class Reference

libzypp 17.38.6

zypp::ResStatus Class Reference

Status bitfield. More...

`#include <zypp/ResStatus.h>`

## Public Types
BitField range definitions.
Note Enlarge FieldType if more bits are needed. It's not yet checked by the compiler.
using | FieldType = uint16_t
using | BitFieldType = bit::BitField<FieldType>
using | StateField = bit::Range<FieldType, 0 , 1>
using | ValidateField = bit::Range<FieldType, StateField::end , 2>
using | TransactField = bit::Range<FieldType, ValidateField::end , 2>
using | TransactByField = bit::Range<FieldType, TransactField::end , 2>
using | TransactDetailField = bit::Range<FieldType, TransactByField::end , 2>
using | LicenceConfirmedField = bit::Range<FieldType, TransactDetailField::end , 1>
using | WeakField = bit::Range<FieldType, LicenceConfirmedField::end, 4>
using | UserLockQueryField = bit::Range<FieldType, WeakField::end , 1>

## Friends
std::ostream & | operator<< (std::ostream &str, const ResStatus &obj)
| relates: ResStatus Stream output
bool | operator== (const ResStatus &lhs, const ResStatus &rhs)
| relates: ResStatus

## Status values.
Each enum corresponds to a BitField range. Note Take care that enumerator values actually fit into the corresponding field. It's not yet checked by the compiler.
enum | StateValue { UNINSTALLED = bit::RangeValue<StateField,0>::value , INSTALLED = bit::RangeValue<StateField,1>::value }
enum | ValidateValue { UNDETERMINED = bit::RangeValue<ValidateField,0>::value , BROKEN = bit::RangeValue<ValidateField,1>::value , SATISFIED = bit::RangeValue<ValidateField,2>::value , NONRELEVANT = bit::RangeValue<ValidateField,3>::value }
enum | TransactValue { KEEP_STATE = bit::RangeValue<TransactField,0>::value , LOCKED = bit::RangeValue<TransactField,1>::value , TRANSACT = bit::RangeValue<TransactField,2>::value }
enum | TransactByValue { SOLVER = bit::RangeValue<TransactByField,0>::value , APPL_LOW = bit::RangeValue<TransactByField,1>::value , APPL_HIGH = bit::RangeValue<TransactByField,2>::value , USER = bit::RangeValue<TransactByField,3>::value }
enum | DetailValue { NO_DETAIL = bit::RangeValue<TransactDetailField,0>::value }
enum | InstallDetailValue { EXPLICIT_INSTALL = bit::RangeValue<TransactDetailField,0>::value , SOFT_INSTALL = bit::RangeValue<TransactDetailField,1>::value }
enum | RemoveDetailValue { EXPLICIT_REMOVE = bit::RangeValue<TransactDetailField,0>::value , SOFT_REMOVE = bit::RangeValue<TransactDetailField,1>::value , DUE_TO_OBSOLETE = bit::RangeValue<TransactDetailField,2>::value , DUE_TO_UPGRADE = bit::RangeValue<TransactDetailField,3>::value }
enum | LicenceConfirmedValue { LICENCE_UNCONFIRMED = bit::RangeValue<LicenceConfirmedField,0>::value , LICENCE_CONFIRMED = bit::RangeValue<LicenceConfirmedField,1>::value }
enum | WeakValue { NO_WEAK = bit::RangeValue<WeakField,0>::value , SUGGESTED = bit::RangeValue<WeakField,1<<0>::value , RECOMMENDED = bit::RangeValue<WeakField,1<<1>::value , ORPHANED = bit::RangeValue<WeakField,1<<2>::value , UNNEEDED = bit::RangeValue<WeakField,1<<3>::value }
enum | UserLockQuery { USERLOCK_NOMATCH = bit::RangeValue<UserLockQueryField,0>::value , USERLOCK_MATCH = bit::RangeValue<UserLockQueryField,1>::value }
| ResStatus ()
| Default ctor.
| ResStatus (bool isInstalled_r)
| Ctor setting the initial .
| ~ResStatus ()
| Dtor.
| ResStatus (const ResStatus &)=default
| ResStatus (ResStatus &&) noexcept=default
ResStatus & | operator= (const ResStatus &)=default
ResStatus & | operator= (ResStatus &&) noexcept=default
BitFieldType | bitfield () const
| Debug helper returning the bitfield.
bool | isLicenceConfirmed () const
void | setLicenceConfirmed (bool toVal_r=true)
bool | isRecommended () const
bool | isSuggested () const
bool | isOrphaned () const
bool | isUnneeded () const
bool | hasWeak () const
void | resetWeak ()
void | setRecommended (bool toVal_r=true)
void | setSuggested (bool toVal_r=true)
void | setOrphaned (bool toVal_r=true)
void | setUnneeded (bool toVal_r=true)
ValidateValue | validate () const
bool | isUndetermined () const
bool | isSatisfied () const
bool | isBroken () const
bool | isNonRelevant () const
std::string | validateValueAsString () const
bool | isInstalled () const
bool | isUninstalled () const
bool | staysInstalled () const
bool | wasInstalled () const
bool | isToBeInstalled () const
bool | staysUninstalled () const
bool | wasUninstalled () const
bool | isToBeUninstalled () const
bool | isLocked () const
bool | isUserLocked () const
bool | isSoftLocked () const
bool | isKept () const
bool | transacts () const
TransactValue | getTransactValue () const
bool | onSystem () const
| True if would be on system after commit.
bool | offSystem () const
| True if would be off system after commit.
bool | isBySolver () const
bool | isByApplLow () const
bool | isByApplHigh () const
bool | isByUser () const
TransactByValue | getTransactByValue () const
bool | setTransactByValue (TransactByValue causer)
bool | isToBeUninstalledDueToObsolete () const
bool | isToBeUninstalledDueToUpgrade () const
bool | isToBeInstalledSoft () const
bool | isToBeInstalledNotSoft () const
bool | isToBeUninstalledSoft () const
static std::string | validateValueAsString (ValidateValue val_r)
| ValidateValue to string used in the history file.
static ValidateValue | stringToValidateValue (const std::string &str_r)
| ValidateValue from string used in the history file.

## Internal hard lock maintenance
struct | resstatus::UserLockQueryManip
bool | isUserLockQueryMatch () const
bool | setTransactValue (TransactValue newVal_r, TransactByValue causer_r)
| Set TransactValue.
bool | maySetTransactValue (TransactValue newVal_r, TransactByValue causer_r)
bool | setLock (bool toLock_r, TransactByValue causer_r)
| Apply a lock (prevent transaction).
bool | maySetLock (bool to_r, TransactByValue causer_r)
bool | setTransact (bool toTansact_r, TransactByValue causer_r)
| Toggle between TRANSACT and KEEP_STATE.
bool | maySetTransact (bool val_r, TransactByValue causer)
bool | setSoftLock (TransactByValue causer_r)
bool | resetTransact (TransactByValue causer_r)
| Not the same as setTransact( false ).
bool | setSoftTransact (bool toTansact_r, TransactByValue causer_r, TransactByValue causerLimit_r)
| Soft toggle between TRANSACT and KEEP_STATE.
bool | setSoftTransact (bool toTansact_r, TransactByValue causer_r)
bool | maySetSoftTransact (bool val_r, TransactByValue causer, TransactByValue causerLimit_r)
bool | maySetSoftTransact (bool val_r, TransactByValue causer)
bool | setToBeInstalled (TransactByValue causer)
bool | maySetToBeInstalled (TransactByValue causer)
bool | setToBeUninstalled (TransactByValue causer)
bool | maySetToBeUninstalled (TransactByValue causer)
bool | setToBeUninstalledDueToObsolete ()
bool | setToBeUninstalledDueToUpgrade (TransactByValue causer)
bool | setToBeInstalledSoft ()
bool | setToBeUninstalledSoft ()
bool | maySetToBeUninstalledSoft ()
bool | isSoftInstall ()
bool | isSoftUninstall ()
bool | setSoftInstall (bool flag)
bool | setSoftUninstall (bool flag)
bool | setUndetermined ()
bool | setSatisfied ()
bool | setBroken ()
bool | setNonRelevant ()
bool | setStatus (const ResStatus &newStatus_r)
void | setUserLockQueryMatch (bool match_r)

## Builtin ResStatus constants.
class | resstatus::StatusBackup
static const ResStatus | toBeInstalled
static const ResStatus | toBeUninstalled
static const ResStatus | toBeUninstalledDueToUpgrade
static const ResStatus | toBeUninstalledDueToObsolete
BitFieldType | _bitfield
| ResStatus (StateValue s, ValidateValue v=UNDETERMINED, TransactValue t=KEEP_STATE, InstallDetailValue i=EXPLICIT_INSTALL, RemoveDetailValue r=EXPLICIT_REMOVE)
| Ctor for intialization of builtin constants.
template<class TField>
bool | fieldValueIs (FieldType val_r) const
| Return whether the corresponding Field has value val_r.
template<class TField>
void | fieldValueAssign (FieldType val_r)
| Set the corresponding Field to value val_r.
template<class TField>
bool | isGreaterThan (FieldType val_r)
| compare two values.
template<class TField>
bool | isLessThan (FieldType val_r)

## Detailed Description

Status bitfield.

- `StateField` Whether the resolvable is or uninstalled (available).
- `ValidateField` Validate status computed by the solver as nonrelevant: it is unimportant for the user satisfied: it important nothing has to be done broken: it is incomplete. So e.g. an update is needed
- `TransactField` Whether to transact this resolvable (delete if installed install if uninstalled). In case the resolvable is locked, only USER may modify the transact bit.
- `TransactByField` Who triggered the transaction. Transaction bit may be reset by higer levels only.
- `TransactDetailField` Reason why the Resolvable transacts. Splitted into `InstallDetailValue` and `RemoveDetailValue` dependent on the kind of transaction.
- `WeakField` The solvable will be recommended/suggested by a to be installed/deleted solvable.

Definition at line 54 of file ResStatus.h.

## Member Typedef Documentation

## ◆ FieldType

using zypp::ResStatus::FieldType = uint16_t

Definition at line 66 of file ResStatus.h.

## ◆ BitFieldType

using zypp::ResStatus::BitFieldType = bit::BitField<FieldType>

Definition at line 67 of file ResStatus.h.

## ◆ StateField

using zypp::ResStatus::StateField = bit::Range<FieldType, 0 , 1>

Definition at line 69 of file ResStatus.h.

## ◆ ValidateField

using zypp::ResStatus::ValidateField = bit::Range<FieldType, StateField::end , 2>

Definition at line 70 of file ResStatus.h.

## ◆ TransactField

using zypp::ResStatus::TransactField = bit::Range<FieldType, ValidateField::end , 2>

Definition at line 71 of file ResStatus.h.

## ◆ TransactByField

using zypp::ResStatus::TransactByField = bit::Range<FieldType, TransactField::end , 2>

Definition at line 72 of file ResStatus.h.

## ◆ TransactDetailField

using zypp::ResStatus::TransactDetailField = bit::Range<FieldType, TransactByField::end , 2>

Definition at line 73 of file ResStatus.h.

## ◆ LicenceConfirmedField

using zypp::ResStatus::LicenceConfirmedField = bit::Range<FieldType, TransactDetailField::end , 1>

Definition at line 74 of file ResStatus.h.

## ◆ WeakField

using zypp::ResStatus::WeakField = bit::Range<FieldType, LicenceConfirmedField::end, 4>

Definition at line 75 of file ResStatus.h.

## ◆ UserLockQueryField

using zypp::ResStatus::UserLockQueryField = bit::Range<FieldType, WeakField::end , 1>

Definition at line 76 of file ResStatus.h.

## Member Enumeration Documentation

## ◆ StateValue

enum zypp::ResStatus::StateValue

Enumerator
UNINSTALLED |
INSTALLED |

Definition at line 89 of file ResStatus.h.

## ◆ ValidateValue

enum zypp::ResStatus::ValidateValue

Enumerator
UNDETERMINED |
BROKEN |
SATISFIED |
NONRELEVANT |

Definition at line 94 of file ResStatus.h.

## ◆ TransactValue

enum zypp::ResStatus::TransactValue

Enumerator
KEEP_STATE |
LOCKED |
TRANSACT |

Definition at line 101 of file ResStatus.h.

## ◆ TransactByValue

enum zypp::ResStatus::TransactByValue

Enumerator
SOLVER |
APPL_LOW |
APPL_HIGH |
USER |

Definition at line 107 of file ResStatus.h.

## ◆ DetailValue

enum zypp::ResStatus::DetailValue

Enumerator
NO_DETAIL | Detail for no transact, i.e. reset any Install/RemoveDetailValue.

Definition at line 115 of file ResStatus.h.

## ◆ InstallDetailValue

enum zypp::ResStatus::InstallDetailValue

Enumerator
EXPLICIT_INSTALL |
SOFT_INSTALL |

Definition at line 120 of file ResStatus.h.

## ◆ RemoveDetailValue

enum zypp::ResStatus::RemoveDetailValue

Enumerator
EXPLICIT_REMOVE |
SOFT_REMOVE |
DUE_TO_OBSOLETE |
DUE_TO_UPGRADE |

Definition at line 125 of file ResStatus.h.

## ◆ LicenceConfirmedValue

enum zypp::ResStatus::LicenceConfirmedValue

Enumerator
LICENCE_UNCONFIRMED |
LICENCE_CONFIRMED |

Definition at line 133 of file ResStatus.h.

## ◆ WeakValue

enum zypp::ResStatus::WeakValue

Enumerator
NO_WEAK |
SUGGESTED |
RECOMMENDED |
ORPHANED |
UNNEEDED |

Definition at line 139 of file ResStatus.h.

## ◆ UserLockQuery

enum zypp::ResStatus::UserLockQuery

Enumerator
USERLOCK_NOMATCH |
USERLOCK_MATCH |

Definition at line 148 of file ResStatus.h.

## Constructor & Destructor Documentation

## ◆ ResStatus() [1/5]

zypp::ResStatus::ResStatus | ( |  | ) |

Default ctor.

Definition at line 33 of file ResStatus.cc.

## ◆ ResStatus() [2/5]

zypp::ResStatus::ResStatus | ( | bool | isInstalled_r | ) |

Ctor setting the initial .

Definition at line 41 of file ResStatus.cc.

## ◆ ~ResStatus()

zypp::ResStatus::~ResStatus | ( |  | ) |

Dtor.

Definition at line 50 of file ResStatus.cc.

## ◆ ResStatus() [3/5]

zypp::ResStatus::ResStatus | ( | const ResStatus & |  | ) |
| default

## ◆ ResStatus() [4/5]

zypp::ResStatus::ResStatus | ( | ResStatus && |  | ) |
| defaultnoexcept

## ◆ ResStatus() [5/5]

zypp::ResStatus::ResStatus | ( | StateValue | s,
|  | ValidateValue | v = UNDETERMINED,
|  | TransactValue | t = KEEP_STATE,
|  | InstallDetailValue | i = EXPLICIT_INSTALL,
|  | RemoveDetailValue | r = EXPLICIT_REMOVE )
| private

Ctor for intialization of builtin constants.

Definition at line 54 of file ResStatus.cc.

## Member Function Documentation

## ◆ operator=() [1/2]

ResStatus & zypp::ResStatus::operator= | ( | const ResStatus & |  | ) |
| default

## ◆ operator=() [2/2]

ResStatus & zypp::ResStatus::operator= | ( | ResStatus && |  | ) |
| defaultnoexcept

## ◆ bitfield()

BitFieldType zypp::ResStatus::bitfield | ( |  | ) | const
| inline

Debug helper returning the bitfield.

It's save to expose the bitfield, as it can't be used to recreate a ResStatus. So it is not possible to bypass transition rules.

Definition at line 176 of file ResStatus.h.

## ◆ isLicenceConfirmed()

bool zypp::ResStatus::isLicenceConfirmed | ( |  | ) | const
| inline

Definition at line 181 of file ResStatus.h.

## ◆ setLicenceConfirmed()

void zypp::ResStatus::setLicenceConfirmed | ( | bool | toVal_r = true | ) |
| inline

Definition at line 184 of file ResStatus.h.

## ◆ isRecommended()

bool zypp::ResStatus::isRecommended | ( |  | ) | const
| inline

Definition at line 188 of file ResStatus.h.

## ◆ isSuggested()

bool zypp::ResStatus::isSuggested | ( |  | ) | const
| inline

Definition at line 191 of file ResStatus.h.

## ◆ isOrphaned()

bool zypp::ResStatus::isOrphaned | ( |  | ) | const
| inline

Definition at line 194 of file ResStatus.h.

## ◆ isUnneeded()

bool zypp::ResStatus::isUnneeded | ( |  | ) | const
| inline

Definition at line 197 of file ResStatus.h.

## ◆ hasWeak()

bool zypp::ResStatus::hasWeak | ( |  | ) | const
| inline

Definition at line 200 of file ResStatus.h.

## ◆ resetWeak()

void zypp::ResStatus::resetWeak | ( |  | ) |
| inline

Definition at line 203 of file ResStatus.h.

## ◆ setRecommended()

void zypp::ResStatus::setRecommended | ( | bool | toVal_r = true | ) |
| inline

Definition at line 206 of file ResStatus.h.

## ◆ setSuggested()

void zypp::ResStatus::setSuggested | ( | bool | toVal_r = true | ) |
| inline

Definition at line 209 of file ResStatus.h.

## ◆ setOrphaned()

void zypp::ResStatus::setOrphaned | ( | bool | toVal_r = true | ) |
| inline

Definition at line 212 of file ResStatus.h.

## ◆ setUnneeded()

void zypp::ResStatus::setUnneeded | ( | bool | toVal_r = true | ) |
| inline

Definition at line 215 of file ResStatus.h.

## ◆ validate()

ValidateValue zypp::ResStatus::validate | ( |  | ) | const
| inline

Definition at line 219 of file ResStatus.h.

## ◆ isUndetermined()

bool zypp::ResStatus::isUndetermined | ( |  | ) | const
| inline

Definition at line 222 of file ResStatus.h.

## ◆ isSatisfied()

bool zypp::ResStatus::isSatisfied | ( |  | ) | const
| inline

Definition at line 225 of file ResStatus.h.

## ◆ isBroken()

bool zypp::ResStatus::isBroken | ( |  | ) | const
| inline

Definition at line 228 of file ResStatus.h.

## ◆ isNonRelevant()

bool zypp::ResStatus::isNonRelevant | ( |  | ) | const
| inline

Definition at line 231 of file ResStatus.h.

## ◆ validateValueAsString() [1/2]

std::string zypp::ResStatus::validateValueAsString | ( |  | ) | const
| inline

Definition at line 234 of file ResStatus.h.

## ◆ validateValueAsString() [2/2]

std::string zypp::ResStatus::validateValueAsString | ( | ValidateValue | val_r | ) |
| static

ValidateValue to string used in the history file.

Definition at line 75 of file ResStatus.cc.

## ◆ stringToValidateValue()

ResStatus::ValidateValue zypp::ResStatus::stringToValidateValue | ( | const std::string & | str_r | ) |
| static

ValidateValue from string used in the history file.

Definition at line 88 of file ResStatus.cc.

## ◆ isInstalled()

bool zypp::ResStatus::isInstalled | ( |  | ) | const
| inline

Definition at line 246 of file ResStatus.h.

## ◆ isUninstalled()

bool zypp::ResStatus::isUninstalled | ( |  | ) | const
| inline

Definition at line 249 of file ResStatus.h.

## ◆ staysInstalled()

bool zypp::ResStatus::staysInstalled | ( |  | ) | const
| inline

Definition at line 254 of file ResStatus.h.

## ◆ wasInstalled()

bool zypp::ResStatus::wasInstalled | ( |  | ) | const
| inline

Definition at line 257 of file ResStatus.h.

## ◆ isToBeInstalled()

bool zypp::ResStatus::isToBeInstalled | ( |  | ) | const
| inline

Definition at line 259 of file ResStatus.h.

## ◆ staysUninstalled()

bool zypp::ResStatus::staysUninstalled | ( |  | ) | const
| inline

Definition at line 262 of file ResStatus.h.

## ◆ wasUninstalled()

bool zypp::ResStatus::wasUninstalled | ( |  | ) | const
| inline

Definition at line 265 of file ResStatus.h.

## ◆ isToBeUninstalled()

bool zypp::ResStatus::isToBeUninstalled | ( |  | ) | const
| inline

Definition at line 267 of file ResStatus.h.

## ◆ isLocked()

bool zypp::ResStatus::isLocked | ( |  | ) | const
| inline

Definition at line 270 of file ResStatus.h.

## ◆ isUserLocked()

bool zypp::ResStatus::isUserLocked | ( |  | ) | const
| inline

Definition at line 273 of file ResStatus.h.

## ◆ isSoftLocked()

bool zypp::ResStatus::isSoftLocked | ( |  | ) | const
| inline

Definition at line 276 of file ResStatus.h.

## ◆ isKept()

bool zypp::ResStatus::isKept | ( |  | ) | const
| inline

Definition at line 279 of file ResStatus.h.

## ◆ transacts()

bool zypp::ResStatus::transacts | ( |  | ) | const
| inline

Definition at line 282 of file ResStatus.h.

## ◆ getTransactValue()

TransactValue zypp::ResStatus::getTransactValue | ( |  | ) | const
| inline

Definition at line 285 of file ResStatus.h.

## ◆ onSystem()

bool zypp::ResStatus::onSystem | ( |  | ) | const
| inline

True if would be on system after commit.

Definition at line 289 of file ResStatus.h.

## ◆ offSystem()

bool zypp::ResStatus::offSystem | ( |  | ) | const
| inline

True if would be off system after commit.

Definition at line 293 of file ResStatus.h.

## ◆ isBySolver()

bool zypp::ResStatus::isBySolver | ( |  | ) | const
| inline

Definition at line 296 of file ResStatus.h.

## ◆ isByApplLow()

bool zypp::ResStatus::isByApplLow | ( |  | ) | const
| inline

Definition at line 299 of file ResStatus.h.

## ◆ isByApplHigh()

bool zypp::ResStatus::isByApplHigh | ( |  | ) | const
| inline

Definition at line 302 of file ResStatus.h.

## ◆ isByUser()

bool zypp::ResStatus::isByUser | ( |  | ) | const
| inline

Definition at line 305 of file ResStatus.h.

## ◆ getTransactByValue()

TransactByValue zypp::ResStatus::getTransactByValue | ( |  | ) | const
| inline

Definition at line 308 of file ResStatus.h.

## ◆ setTransactByValue()

bool zypp::ResStatus::setTransactByValue | ( | TransactByValue | causer | ) |
| inline

Definition at line 311 of file ResStatus.h.

## ◆ isToBeUninstalledDueToObsolete()

bool zypp::ResStatus::isToBeUninstalledDueToObsolete | ( |  | ) | const
| inline

Definition at line 321 of file ResStatus.h.

## ◆ isToBeUninstalledDueToUpgrade()

bool zypp::ResStatus::isToBeUninstalledDueToUpgrade | ( |  | ) | const
| inline

Definition at line 324 of file ResStatus.h.

## ◆ isToBeInstalledSoft()

bool zypp::ResStatus::isToBeInstalledSoft | ( |  | ) | const
| inline

Definition at line 327 of file ResStatus.h.

## ◆ isToBeInstalledNotSoft()

bool zypp::ResStatus::isToBeInstalledNotSoft | ( |  | ) | const
| inline

Definition at line 330 of file ResStatus.h.

## ◆ isToBeUninstalledSoft()

bool zypp::ResStatus::isToBeUninstalledSoft | ( |  | ) | const
| inline

Definition at line 333 of file ResStatus.h.

## ◆ setUserLockQueryMatch()

void zypp::ResStatus::setUserLockQueryMatch | ( | bool | match_r | ) |
| inlineprivate

Definition at line 341 of file ResStatus.h.

## ◆ isUserLockQueryMatch()

bool zypp::ResStatus::isUserLockQueryMatch | ( |  | ) | const
| inline

Definition at line 345 of file ResStatus.h.

## ◆ setTransactValue()

bool zypp::ResStatus::setTransactValue | ( | TransactValue | newVal_r,
|  | TransactByValue | causer_r )
| inline

Set TransactValue.

Convenience to set TransactValue from enum.

Definition at line 363 of file ResStatus.h.

## ◆ maySetTransactValue()

bool zypp::ResStatus::maySetTransactValue | ( | TransactValue | newVal_r,
|  | TransactByValue | causer_r )
| inline

Definition at line 380 of file ResStatus.h.

## ◆ setLock()

bool zypp::ResStatus::setLock | ( | bool | toLock_r,
|  | TransactByValue | causer_r )
| inline

Apply a lock (prevent transaction).

Currently by USER or APPL_HIGH only, but who knows... Set LOCKED from KEEP_STATE to be sure all transaction details were reset properly.

Definition at line 393 of file ResStatus.h.

## ◆ maySetLock()

bool zypp::ResStatus::maySetLock | ( | bool | to_r,
|  | TransactByValue | causer_r )
| inline

Definition at line 425 of file ResStatus.h.

## ◆ setTransact()

bool zypp::ResStatus::setTransact | ( | bool | toTansact_r,
|  | TransactByValue | causer_r )
| inline

Toggle between TRANSACT and KEEP_STATE.

LOCKED state means KEEP_STATE. But in contrary to KEEP_STATE, LOCKED state is immutable for causer_r less than TransactByValue. KEEP_STATE may be changed by any causer_r.

Definition at line 438 of file ResStatus.h.

## ◆ maySetTransact()

bool zypp::ResStatus::maySetTransact | ( | bool | val_r,
|  | TransactByValue | causer )
| inline

Definition at line 469 of file ResStatus.h.

## ◆ setSoftLock()

bool zypp::ResStatus::setSoftLock | ( | TransactByValue | causer_r | ) |
| inline

Definition at line 478 of file ResStatus.h.

## ◆ resetTransact()

bool zypp::ResStatus::resetTransact | ( | TransactByValue | causer_r | ) |
| inline

Not the same as setTransact( false ).

Definition at line 490 of file ResStatus.h.

## ◆ setSoftTransact() [1/2]

bool zypp::ResStatus::setSoftTransact | ( | bool | toTansact_r,
|  | TransactByValue | causer_r,
|  | TransactByValue | causerLimit_r )
| inline

Soft toggle between TRANSACT and KEEP_STATE.

Similar to setTransact, but leaving KEEP_STATE also requires a superior causerLimit_r. So this is a kind of soft lock.

// SOLVER wants to set TRANSACT, iff KEEP_STATE is
// not superior to APPL_LOW.
setSoftTransact( true, SOLVER, APPL_LOW );
zypp::ResStatus::APPL_LOW
@ APPL_LOW
Definition ResStatus.h:110
zypp::ResStatus::SOLVER
@ SOLVER
Definition ResStatus.h:109
zypp::ResStatus::setSoftTransact
bool setSoftTransact(bool toTansact_r, TransactByValue causer_r, TransactByValue causerLimit_r)
Soft toggle between TRANSACT and KEEP_STATE.
Definition ResStatus.h:508

Definition at line 508 of file ResStatus.h.

## ◆ setSoftTransact() [2/2]

bool zypp::ResStatus::setSoftTransact | ( | bool | toTansact_r,
|  | TransactByValue | causer_r )
| inline

Definition at line 521 of file ResStatus.h.

## ◆ maySetSoftTransact() [1/2]

bool zypp::ResStatus::maySetSoftTransact | ( | bool | val_r,
|  | TransactByValue | causer,
|  | TransactByValue | causerLimit_r )
| inline

Definition at line 524 of file ResStatus.h.

## ◆ maySetSoftTransact() [2/2]

bool zypp::ResStatus::maySetSoftTransact | ( | bool | val_r,
|  | TransactByValue | causer )
| inline

Definition at line 533 of file ResStatus.h.

## ◆ setToBeInstalled()

bool zypp::ResStatus::setToBeInstalled | ( | TransactByValue | causer | ) |
| inline

Definition at line 536 of file ResStatus.h.

## ◆ maySetToBeInstalled()

bool zypp::ResStatus::maySetToBeInstalled | ( | TransactByValue | causer | ) |
| inline

Definition at line 542 of file ResStatus.h.

## ◆ setToBeUninstalled()

bool zypp::ResStatus::setToBeUninstalled | ( | TransactByValue | causer | ) |
| inline

Definition at line 550 of file ResStatus.h.

## ◆ maySetToBeUninstalled()

bool zypp::ResStatus::maySetToBeUninstalled | ( | TransactByValue | causer | ) |
| inline

Definition at line 556 of file ResStatus.h.

## ◆ setToBeUninstalledDueToObsolete()

bool zypp::ResStatus::setToBeUninstalledDueToObsolete | ( |  | ) |
| inline

Definition at line 567 of file ResStatus.h.

## ◆ setToBeUninstalledDueToUpgrade()

bool zypp::ResStatus::setToBeUninstalledDueToUpgrade | ( | TransactByValue | causer | ) |
| inline

Definition at line 574 of file ResStatus.h.

## ◆ setToBeInstalledSoft()

bool zypp::ResStatus::setToBeInstalledSoft | ( |  | ) |
| inline

Definition at line 581 of file ResStatus.h.

## ◆ setToBeUninstalledSoft()

bool zypp::ResStatus::setToBeUninstalledSoft | ( |  | ) |
| inline

Definition at line 591 of file ResStatus.h.

## ◆ maySetToBeUninstalledSoft()

bool zypp::ResStatus::maySetToBeUninstalledSoft | ( |  | ) |
| inline

Definition at line 601 of file ResStatus.h.

## ◆ isSoftInstall()

bool zypp::ResStatus::isSoftInstall | ( |  | ) |
| inline

Definition at line 609 of file ResStatus.h.

## ◆ isSoftUninstall()

bool zypp::ResStatus::isSoftUninstall | ( |  | ) |
| inline

Definition at line 613 of file ResStatus.h.

## ◆ setSoftInstall()

bool zypp::ResStatus::setSoftInstall | ( | bool | flag | ) |
| inline

Definition at line 617 of file ResStatus.h.

## ◆ setSoftUninstall()

bool zypp::ResStatus::setSoftUninstall | ( | bool | flag | ) |
| inline

Definition at line 622 of file ResStatus.h.

## ◆ setUndetermined()

bool zypp::ResStatus::setUndetermined | ( |  | ) |
| inline

Definition at line 627 of file ResStatus.h.

## ◆ setSatisfied()

bool zypp::ResStatus::setSatisfied | ( |  | ) |
| inline

Definition at line 633 of file ResStatus.h.

## ◆ setBroken()

bool zypp::ResStatus::setBroken | ( |  | ) |
| inline

Definition at line 639 of file ResStatus.h.

## ◆ setNonRelevant()

bool zypp::ResStatus::setNonRelevant | ( |  | ) |
| inline

Definition at line 645 of file ResStatus.h.

## ◆ setStatus()

bool zypp::ResStatus::setStatus | ( | const ResStatus & | newStatus_r | ) |
| inline

Definition at line 651 of file ResStatus.h.

## ◆ fieldValueIs()

template<class TField>

bool zypp::ResStatus::fieldValueIs | ( | FieldType | val_r | ) | const
| inlineprivate

Return whether the corresponding Field has value val_r.

Definition at line 684 of file ResStatus.h.

## ◆ fieldValueAssign()

template<class TField>

void zypp::ResStatus::fieldValueAssign | ( | FieldType | val_r | ) |
| inlineprivate

Set the corresponding Field to value val_r.

Definition at line 690 of file ResStatus.h.

## ◆ isGreaterThan()

template<class TField>

bool zypp::ResStatus::isGreaterThan | ( | FieldType | val_r | ) |
| inlineprivate

compare two values.

Definition at line 696 of file ResStatus.h.

## ◆ isLessThan()

template<class TField>

bool zypp::ResStatus::isLessThan | ( | FieldType | val_r | ) |
| inlineprivate

Definition at line 700 of file ResStatus.h.

## Friends And Related Symbol Documentation

## ◆ resstatus::UserLockQueryManip

friend struct resstatus::UserLockQueryManip
| friend

Definition at line 339 of file ResStatus.h.

## ◆ resstatus::StatusBackup

friend class resstatus::StatusBackup
| friend

Definition at line 704 of file ResStatus.h.

## ◆ operator<<

std::ostream & operator<< | ( | std::ostream & | str,
|  | const ResStatus & | obj )
| friend

relates: ResStatus Stream output

Definition at line 102 of file ResStatus.cc.

## ◆ operator==

bool operator== | ( | const ResStatus & | lhs,
|  | const ResStatus & | rhs )
| friend

relates: ResStatus

Definition at line 719 of file ResStatus.h.

## Member Data Documentation

## ◆ toBeInstalled

const ResStatus zypp::ResStatus::toBeInstalled
| static

Definition at line 667 of file ResStatus.h.

## ◆ toBeUninstalled

const ResStatus zypp::ResStatus::toBeUninstalled
| static

Definition at line 668 of file ResStatus.h.

## ◆ toBeUninstalledDueToUpgrade

const ResStatus zypp::ResStatus::toBeUninstalledDueToUpgrade
| static

Definition at line 669 of file ResStatus.h.

## ◆ toBeUninstalledDueToObsolete

const ResStatus zypp::ResStatus::toBeUninstalledDueToObsolete
| static

Definition at line 670 of file ResStatus.h.

## ◆ _bitfield

BitFieldType zypp::ResStatus::_bitfield
| private

Definition at line 705 of file ResStatus.h.

The documentation for this class was generated from the following files:

- zypp/ResStatus.h
- zypp/ResStatus.cc